#version 150

in  vec3 in_Position;
uniform mat4 myMatrix;
uniform float angle;

void main(void)
{
	mat4 r, t, s;
	float a = angle + gl_InstanceID * 0.5;
	
	// Here I build some matrices based on the instance id
	r[0] = vec4(cos(a), -sin(a), 0, 0);
	r[1] = vec4(sin(a), cos(a), 0, 0);
	r[2] = vec4(0, 0, 1, 0);
	r[3] = vec4(0, 0, 0, 1);
	
	t[0] = vec4(1,0,0,0);
	t[1] = vec4(0,1,0,0);
	t[2] = vec4(0,0,1,0);
	t[3] = vec4(cos(a),sin(a),sin(a),1);
	
	s[0] = vec4(0.3,0,0,0);
	s[1] = vec4(0,0.3,0,0);
	s[2] = vec4(0,0,0.3,0);
	s[3] = vec4(0,0,0,1.0);
	
	gl_Position = t*r * myMatrix*s* vec4(in_Position, 1.0);
}
